\version "2.24.1"

#(define (make-dynamic-extra dynamic string)
 (let ((dtext (markup #:whiteout #:line (dynamic #:hspace 0.0 #:normal-text #:italic string)))
       (dvol  (assoc-ref absolute-volume-alist dynamic)))
     (set! absolute-volume-alist (assoc-set! absolute-volume-alist dtext dvol))
     (make-music
       'AbsoluteDynamicEvent
       'tweaks
         ;; calculate centering for text
;        (list (cons (quote X-offset) (+ -0.5 (* -0.5 (string-length dynamic)))))
         (list (cons 'X-offset (- 0.6 (/ (string-length dynamic) 2))))
       'text dtext)))

#(define (make-extra-dynamic dynamic string)
 (let ((dtext (markup #:whiteout #:line (#:normal-text #:italic string #:hspace 0.0 dynamic)))
       (dvol  (assoc-ref absolute-volume-alist dynamic)))
     (set! absolute-volume-alist (assoc-set! absolute-volume-alist dtext dvol))
     (make-music
       'AbsoluteDynamicEvent
       'tweaks
         ;; calculate centering for text
         (list (cons 'X-offset (- (string-length string))))
       'text dtext)))

piup       = #(make-extra-dynamic "p" "più")
pocof      = #(make-extra-dynamic "f" "poco")
pocofz     = #(make-extra-dynamic "sfz" "poco")
semprep    = #(make-extra-dynamic "p" "sempre")

farco      = #(make-dynamic-extra "f"  (markup (#:normal-text "arco")))
parco      = #(make-dynamic-extra "p"  (markup (#:normal-text "arco")))
ppizz      = #(make-dynamic-extra "p"  (markup (#:normal-text "pizz.")))
pdolce     = #(make-dynamic-extra "p"  "e dolce")
ppdolce    = #(make-dynamic-extra "pp" "dolce")
pplegno    = #(make-dynamic-extra "pp" "col legno")
pcantabile = #(make-dynamic-extra "p"  "cantabile")
pstaccato  = #(make-dynamic-extra "p"  "staccato")
ppstaccato = #(make-dynamic-extra "pp" "staccato")

fpp        = #(make-dynamic-script "fpp")
fsfz       = #(make-dynamic-script "f sfz")
psfz       = #(make-dynamic-script "p sfz")

ppptext     = \markup \normal-text \italic "pianissimo"
pianissimo  = \tweak DynamicText.self-alignment-X #-0.8 #(make-dynamic-script ppptext)
calandotext = \markup \normal-text \italic "calando"
calando     = \tweak DynamicText.self-alignment-X #-0.8 #(make-dynamic-script calandotext)

#(begin
  (define dirs #f)
  (define now -inf.0)
  (for-each
    (lambda (suffix)
      (let ((file (format #f "~3,'0d~a.directions" N suffix)))
        (if (access? file F_OK) (delete-file file))))
    '("" "a" "b" "c"))
)

Print_directions =
#(lambda (context)
  (make-engraver

    ((initialize translator)
      (if (not final)
        (let* ((outfile    (ly:output-def-lookup $defaultpaper 'output-filename #f))
               (prefix     (substring outfile 0 (string-index outfile #\-)))
               (directions (string-join `(,prefix "directions") ".")))
          (set! dirs (open-file directions "a"))
          (set! now -inf.0))))

    ((finalize translator)
      (if (not final)
        (begin
          (format dirs "~%")
          (force-output dirs))))

    (listeners
      ((articulation-event engraver event)
        (if (not final)
          (let* ((moment       (ly:moment-main (ly:context-current-moment context)))
                 (articulation (format #f "~a" (ly:event-property event 'articulation-type)))
                 (parent       (ly:context-property-where-defined context 'currentBarNumber))
                 (bar          (ly:context-property parent 'currentBarNumber))
                 (position     (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format dirs "~%~5@a~6@a" bar position)))
           (format dirs "~10@a" (substring articulation 0 (min (string-length articulation) 9))))))
      ((absolute-dynamic-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-current-moment context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format dirs "~%~5@a~6@a" bar position)))
           (format dirs "~10@a" (substring dyntext 0 (min (string-length dyntext) 9))))))
      ((crescendo-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-current-moment context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format dirs "~%~5@a~6@a" bar position)))
           (format dirs "~10@a" "cresc"))))
      ((decrescendo-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main (ly:context-current-moment context)))
                 (dyntext  (format #f "~a" (ly:event-property event 'text)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (> moment now) (begin (set! now moment) (format dirs "~%~5@a~6@a" bar position)))
           (format dirs "~10@a" "decresc"))))
      ((slur-event engraver event)
        (if (not final)
          (let* ((moment   (ly:moment-main  (ly:context-current-moment context)))
                 (grace    (ly:moment-grace (ly:context-current-moment context)))
                 (parent   (ly:context-property-where-defined context 'currentBarNumber))
                 (bar      (ly:context-property parent 'currentBarNumber))
                 (position (ly:moment-main (ly:context-property parent 'measurePosition))))
           (if (negative? grace)
             (begin
               (if (> moment now) (begin (set! now moment) (format dirs "~%~5@a~6@a" bar position)))
               (format dirs "~10@a" "grace"))))))
    )))
