\version "2.24.1"

#(define (filtermusic edition? alist)
  (for-each
    (lambda (instrument)
      (let* ((instdata (cdr instrument)))
        (cond
          ((ly:music? instdata) ; instdata is music for one instrument
            (set! alist (assoc-set! alist (car instrument) (music-filter edition? instdata))))
          ((list? instdata) ; instdata is a list of instuments + music
            (filtermusic edition? instdata))
          ((ly:pitch? instdata) ; instdata is instrument transposition data - do nothing
            #t))))
    alist)
  ; return updated alist
  alist)

#(define (edition movement)
   (let* ((mvt      (ly:parser-lookup movement))
          (edition? (tags-keep-predicate `(,Edition ,score?))))
     (ly:parser-define! movement (filtermusic edition? mvt))))

#(define getmvts
   (let* ((score     (ly:gulp-file (format #f "~3,'0d-score.ly" N))) ; read this score
          (book      (substring score (string-contains score "\\book"))) ; retain only part starting \book
          (matches   (map match:substring (list-matches "[IV]+[a-z]?.structure" book)))) ; list of matches to regex
      ; extract movement name
      (map (lambda (match) (string-drop-right match (string-length ".structure"))) matches)))

#(for-each (lambda (mvt) (edition (string->symbol mvt))) getmvts)
