\version "2.24.1"

outfile = #(define-void-function (n variant) (integer? string?)
  (if final
    (if imslp
      (bookOutputName (format #f "~3,'0d~a-imslp" n variant))
      (bookOutputName (format #f "~3,'0d~a-score" n variant)))
    (bookOutputName (format #f "~3,'0d~a-proof" n variant))))

\outfile \N ""

maxsystems = #(define-void-function (n) (integer?)
  (if final
    (ly:output-def-set-variable! (ly:book-paper $current-bookpart) 'max-systems-per-page n)
    (ly:output-def-set-variable! (ly:book-paper $current-bookpart) 'page-spacing-weight 0)))

#(define (mdashodd layout props arg)
  (if (chain-assoc-get 'header:nickname props)
    (interpret-markup layout props arg)
    empty-stencil))

#(define (mdasheven layout props arg)
  (if (chain-assoc-get 'header:variant props)
    (interpret-markup layout props arg)
    empty-stencil))

#(define (composed layout props arg)
  (define c (chain-assoc-get 'header:composed props))
  (if c
    (interpret-markup layout props (markup (#:concat ("(" c ")"))))
    empty-stencil))

\paper {
  left-margin = 12\staff-space
  ragged-last-bottom = ##f
  top-system-spacing.basic-distance = 10
  markup-system-spacing.basic-distance = 8
  #(when (eq? score? 'score) (set! system-system-spacing (assq-set! system-system-spacing 'padding 12)))

  bookTitleMarkup = \markup {
    \override #'(baseline-skip . 4.5)
    \column {
      \fill-line { \fromproperty #'header:dedication }
      \override #'(baseline-skip . 3.5)
      \column {
        \fill-line { \huge \larger \larger \bold \fromproperty #'header:title }
        \fill-line { \large \bold \fromproperty #'header:subsubtitle }
        \vspace #0.5
        \fill-line { \huge \larger \fromproperty #'header:subtitle }
      }
      \override #'(baseline-skip . 3.0)
      \column {
        \fill-line { \null \fromproperty #'header:composer }
        \fill-line { \null \line { \fromproperty #'header:opus \on-the-fly \composed \null } }
      }
    }
  }
  scoreTitleMarkup = \markup {
    \fill-line { \null \huge \bold \fromproperty #'header:piece \null }
  }

  oddHeaderMarkup = \markup \fill-line {
    \null
    \unless \on-first-page-of-part \normalsize \line { "Symphony Nº" #(number->string N)
                                                         \on-the-fly \mdashodd "—"
                                                         \italic \fromproperty #'header:nickname
                                                       }
    \if \should-print-page-number \teeny \fromproperty #'page:page-number-string
  }
  evenHeaderMarkup = \markup \fill-line {
    \if \should-print-page-number \teeny \fromproperty #'page:page-number-string
    \unless \on-first-page-of-part \normalsize \line { \fromproperty #'header:piece
                                                         \on-the-fly \mdasheven "—"
                                                         \italic \fromproperty #'header:variant
                                                       }
    \null
  }
  oddFooterMarkup = \markup \null
}
